<template>
  <v-layout row justify-center>
    <v-dialog v-model="dialog" persistent max-width="500px">
      <v-card v-loading="loading">
        <v-card-title>
          <span class="headline">Create</span>
        </v-card-title>
        <v-card-text>
          <v-form ref="form" v-model="valid" lazy-validation v-if="dialog">
            <v-text-field
              label="Name"
              v-model="form.name"
              required/>
            <v-menu
              :close-on-content-click="false"
              v-model="startMenu"
              :nudge-right="40"
              lazy
              transition="scale-transition"
              offset-y
              full-width
              max-width="290px"
              min-width="290px">
              <v-text-field slot="activator"
                v-model="form.start"
                label="Start Date"
                persistent-hint
                readonly/>
              <v-date-picker v-model="form.start"
              no-title @input="startMenu = false"/>
            </v-menu>
            <v-menu
              :close-on-content-click="false"
              v-model="endMenu"
              :nudge-right="40"
              lazy
              transition="scale-transition"
              offset-y
              full-width
              max-width="290px"
              min-width="290px">
              <v-text-field slot="activator"
                v-model="form.end"
                label="End Date"
                persistent-hint
                readonly/>
              <v-date-picker v-model="form.end"
              no-title @input="endMenu = false"/>
            </v-menu>
            <v-text-field
              label="Base Capital"
              v-model="form.capital"
              required/>
              <v-select :items="strategyList" label="Strategy" required/>
          </v-form>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn @click.native="commit" color="info">commit</v-btn>
          <v-btn @click.native="close">cancel</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-layout>
</template>
<script>
export default {
  data () {
    return {
      dialog: false,
      valid: true,
      startMenu: false,
      endMenu: false,
      form: {
        name: '',
        start: null,
        end: null,
        capital: ''
      },
      loading: false
    }
  },
  computed: {
    strategyList () {
      let list = this.$store.getters['backtest/strategyList'] || []
      return list
    }
  },
  methods: {
    async show () {
      this.dialog = true
    },
    commit () {
      this.loading = true
      setTimeout(() => {
        this.$router.push('/backtest/1')
        this.close()
      }, 500)
    },
    close () {
      this.dialog = false
      this.loading = false
    }
  }
}
</script>
